commit 4c72a54cb0b2745713595adaecfc1bad548c03e0
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Jul 15 13:21:06 2019 +0200

    Massive overhaul:
    - updated to a new version of AMiRo-LLD
    - tests (formerly unit tests) are now split onto multiple parts:
      - there are "global" tests for each driver etc.
      - there is an individual part for each module, e.g. if there are multiple instances of the same periphery
    - a lot of minor enhancements

diff --git a/modules/DiWheelDrive_1-1/module.h b/modules/DiWheelDrive_1-1/module.h
index e47d147..a6168ec 100644
--- a/modules/DiWheelDrive_1-1/module.h
+++ b/modules/DiWheelDrive_1-1/module.h
@@ -332,27 +332,28 @@ extern ROMCONST char* moduleShellPrompt;
 }
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldA3906.shellcmd);                \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldAt24c01b.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldHmc5883l.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldIna219.shellcmd);               \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldL3g4200d.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldLed.shellcmd);                  \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldLis331dlh.shellcmd);            \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldLtc4412.shellcmd);              \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldPca9544a.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldVcnl4020.shellcmd);             \
+  /* initialize tests and add to shell */                                     \
+  aosShellAddCommand(&aos.shell, &moduleTestA3906ShellCmd);                   \
+  aosShellAddCommand(&aos.shell, &moduleTestAt24c01bShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestHmc5883lShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestIna219ShellCmd);                  \
+  aosShellAddCommand(&aos.shell, &moduleTestL3g4200dShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestLis331dlhShellCmd);               \
+  aosShellAddCommand(&aos.shell, &moduleTestLtc4412ShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestPca9544aShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestTps62113ShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestVcnl4020ShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
 
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   /* I2C */                                                                   \
@@ -378,7 +379,7 @@ extern ROMCONST char* moduleShellPrompt;
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
   /* PWM */                                                                   \
   pwmStop(&MODULE_HAL_PWM_DRIVE);                                             \
   /* QEI */                                                                   \
@@ -510,77 +511,71 @@ extern VCNL4020Driver moduleLldProximity;
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <ut_alld_A3906_v1.h>
-#include <ut_alld_AT24C01B_v1.h>
-#include <ut_alld_HMC5883L_v1.h>
-#include <ut_alld_INA219_v1.h>
-#include <ut_alld_L3G4200D_v1.h>
-#include <ut_alld_LED_v1.h>
-#include <ut_alld_LIS331DLH_v1.h>
-#include <ut_alld_LTC4412_v1.h>
-#include <ut_alld_PCA9544A_v1.h>
-#include <ut_alld_TPS6211x_v1.h>
-#include <ut_alld_VCNL4020_v1.h>
 
 /**
- * @brief   A3906 (motor driver) unit test object.
+ * @brief   A3906 (motor driver) test command.
  */
-extern aos_unittest_t moduleUtAlldA3906;
+extern aos_shellcommand_t moduleTestA3906ShellCmd;
 
 /**
- * @brief   AT24C01BN-SH-B (EEPROM) unit test object.
+ * @brief   AT24C01BN-SH-B (EEPROM) test command.
  */
-extern aos_unittest_t moduleUtAlldAt24c01b;
+extern aos_shellcommand_t moduleTestAt24c01bShellCmd;
 
 /**
- * @brief   HMC5883L (compass) unit test object.
+ * @brief   HMC5883L (compass) test command.
  */
-extern aos_unittest_t moduleUtAlldHmc5883l;
+extern aos_shellcommand_t moduleTestHmc5883lShellCmd;
 
 /**
- * @brief   INA219 (power monitor) unit test object.
+ * @brief   INA219 (power monitor) test command.
  */
-extern aos_unittest_t moduleUtAlldIna219;
+extern aos_shellcommand_t moduleTestIna219ShellCmd;
 
 /**
- * @brief   L3G4200D (gyroscope) unit test object.
+ * @brief   L3G4200D (gyroscope) test command.
  */
-extern aos_unittest_t moduleUtAlldL3g4200d;
+extern aos_shellcommand_t moduleTestL3g4200dShellCmd;
 
 /**
- * @brief   Status LED unit test object.
+ * @brief   Status LED test command.
  */
-extern aos_unittest_t moduleUtAlldLed;
+extern aos_shellcommand_t moduleTestLedShellCmd;
 
 /**
- * @brief   LIS331DLH (accelerometer) unit test object.
+ * @brief   LIS331DLH (accelerometer) test command.
  */
-extern aos_unittest_t moduleUtAlldLis331dlh;
+extern aos_shellcommand_t moduleTestLis331dlhShellCmd;
 
 /**
- * @brief   LTC4412 (power path controller) unit test object.
+ * @brief   LTC4412 (power path controller) test command.
  */
-extern aos_unittest_t moduleUtAlldLtc4412;
+extern aos_shellcommand_t moduleTestLtc4412ShellCmd;
 
 /**
- * @brief   PCA9544A (I2C multiplexer) unit test object.
+ * @brief   PCA9544A (I2C multiplexer) test command.
  */
-extern aos_unittest_t moduleUtAlldPca9544a;
+extern aos_shellcommand_t moduleTestPca9544aShellCmd;
 
 /**
- * @brief   TPS62113 (step-down converter) unit test object.
+ * @brief   TPS62113 (step-down converter) test command.
  */
-extern aos_unittest_t moduleUtAlldTps62113;
+extern aos_shellcommand_t moduleTestTps62113ShellCmd;
 
 /**
- * @brief   VCNL4020 (proximity sensor) unit test object.
+ * @brief   VCNL4020 (proximity sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldVcnl4020;
+extern aos_shellcommand_t moduleTestVcnl4020ShellCmd;
+
+/**
+ * @brief   Entire module test command.
+ */
+extern aos_shellcommand_t moduleTestAllShellCmd;
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 