commit 4c72a54cb0b2745713595adaecfc1bad548c03e0
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Jul 15 13:21:06 2019 +0200

    Massive overhaul:
    - updated to a new version of AMiRo-LLD
    - tests (formerly unit tests) are now split onto multiple parts:
      - there are "global" tests for each driver etc.
      - there is an individual part for each module, e.g. if there are multiple instances of the same periphery
    - a lot of minor enhancements

diff --git a/modules/LightRing_1-0/module.h b/modules/LightRing_1-0/module.h
index 9031297..6e36371 100644
--- a/modules/LightRing_1-0/module.h
+++ b/modules/LightRing_1-0/module.h
@@ -217,19 +217,20 @@ extern ROMCONST char* moduleShellPrompt;
 }
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldAt24c01b.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTlc5947.shellcmd);              \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTps2051bdbv.shellcmd);          \
+  /* initialize tests and add to shell */                                     \
+  aosShellAddCommand(&aos.shell, &moduleTestAt24c01bShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestTlc5947ShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestTps2051bdbvShellCmd);             \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
 
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   /* I2C */                                                                   \
@@ -244,7 +245,7 @@ extern ROMCONST char* moduleShellPrompt;
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
   /* SPI */                                                                   \
   spiStop(&MODULE_HAL_SPI_LIGHT);                                             \
   spiStop(&MODULE_HAL_SPI_WL);                                                \
@@ -310,7 +311,7 @@ extern ROMCONST char* moduleShellPrompt;
 extern AT24C01BDriver moduleLldEeprom;
 
 /**
- * @brief   LED PWM driver.
+ * @brief   24 channel PWM LED driver.
  */
 extern TLC5947Driver moduleLldLedPwm;
 
@@ -323,30 +324,31 @@ extern TPS20xxBDriver moduleLldPowerSwitchLaser;
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <ut_alld_AT24C01B_v1.h>
-#include <ut_alld_TLC5947_v1.h>
-#include <ut_alld_TPS20xxB_v1.h>
 
 /**
- * @brief   EEPROM unit test object.
+ * @brief   AT24C01BN-SH-B (EEPROM) test command.
  */
-extern aos_unittest_t moduleUtAlldAt24c01b;
+extern aos_shellcommand_t moduleTestAt24c01bShellCmd;
 
 /**
- * @brief   LED PWM driver unit test object.
+ * @brief   TLC5947 (24 channel PWM LED driver) test command
  */
-extern aos_unittest_t moduleUtAlldTlc5947;
+extern aos_shellcommand_t moduleTestTlc5947ShellCmd;
 
 /**
- * @brief   Current-limited power switch (Laser output)
+ * @brief   TPS2051BDBV (Current-limited power switch) test command
  */
-extern aos_unittest_t moduleUtAlldTps2051bdbv;
+extern aos_shellcommand_t moduleTestTps2051bdbvShellCmd;
 
+/**
+ * @brief   Entire module test command.
+ */
+extern aos_shellcommand_t moduleTestAllShellCmd;
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 