commit 4c72a54cb0b2745713595adaecfc1bad548c03e0
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Jul 15 13:21:06 2019 +0200

    Massive overhaul:
    - updated to a new version of AMiRo-LLD
    - tests (formerly unit tests) are now split onto multiple parts:
      - there are "global" tests for each driver etc.
      - there is an individual part for each module, e.g. if there are multiple instances of the same periphery
    - a lot of minor enhancements

diff --git a/modules/LightRing_1-2/module.h b/modules/LightRing_1-2/module.h
index fd221db..ffb29a4 100644
--- a/modules/LightRing_1-2/module.h
+++ b/modules/LightRing_1-2/module.h
@@ -298,18 +298,19 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Unit test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldAt24c01b.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldIna219.shellcmd);               \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldLed.shellcmd);                  \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldMic9404x.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTlc5947.shellcmd);              \
+  /* initialize tests and add to shell */                                     \
+  aosShellAddCommand(&aos.shell, &moduleTestAt24c01bShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestIna219ShellCmd);                  \
+  aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestMic9404xShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestTlc5947ShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
 
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   /* I2C */                                                                   \
@@ -324,7 +325,7 @@ extern ROMCONST char* moduleShellPrompt;
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
   /* SPI */                                                                   \
   spiStop(&MODULE_HAL_SPI_LIGHT);                                             \
   /* I2C */                                                                   \
@@ -393,7 +394,7 @@ extern ROMCONST char* moduleShellPrompt;
 #include <alld_INA219.h>
 #include <alld_LED.h>
 #include <alld_MIC9404x.h>
-//#include <alld_SNx5C3221E.h>
+// TODO: add SNx5C3221E
 #include <alld_TLC5947.h>
 
 /**
@@ -437,8 +438,10 @@ extern MIC9404xDriver moduleLldPowerSwitchV50;
  */
 extern MIC9404xDriver moduleLldPowerSwitchVsys;
 
+// TODO: add SNx5C3221E
+
 /**
- * @brief   LED PWM driver.
+ * @brief   24 channel PWM LED driver.
  */
 extern TLC5947Driver moduleLldLedPwm;
 
@@ -446,42 +449,43 @@ extern TLC5947Driver moduleLldLedPwm;
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <ut_alld_AT24C01B_v1.h>
-#include <ut_alld_INA219_v1.h>
-#include <ut_alld_LED_v1.h>
-#include <ut_alld_MIC9404x_v1.h>
-//#include <ut_alld_SNx5C3221E_v1.h>
-#include <ut_alld_TLC5947_v1.h>
 
 /**
- * @brief   EEPROM unit test object.
+ * @brief   AT24C01BN-SH-B (EEPROM) test command.
  */
-extern aos_unittest_t moduleUtAlldAt24c01b;
+extern aos_shellcommand_t moduleTestAt24c01bShellCmd;
 
 /**
- * @brief   INA219 (power monitor) unit test object.
+ * @brief   INA219 (power monitor) test command.
  */
-extern aos_unittest_t moduleUtAlldIna219;
+extern aos_shellcommand_t moduleTestIna219ShellCmd;
 
 /**
- * @brief   Status LED unit test object.
+ * @brief   Status LED test command.
  */
-extern aos_unittest_t moduleUtAlldLed;
+extern aos_shellcommand_t moduleTestLedShellCmd;
+
+/**
+ * @brief   MIC9404x (power switch) test command.
+ */
+extern aos_shellcommand_t moduleTestMic9404xShellCmd;
+
+// TODO: add SNx5C3221E
 
 /**
- * @brief   Power switch unit test object.
+ * @brief   TLC5947 (24 channel PWM LED driver) test command.
  */
-extern aos_unittest_t moduleUtAlldMic9404x;
+extern aos_shellcommand_t moduleTestTlc5947ShellCmd;
 
 /**
- * @brief   LED PWM driver unit test object.
+ * @brief   Entire module test command.
  */
-extern aos_unittest_t moduleUtAlldTlc5947;
+extern aos_shellcommand_t moduleTestAllShellCmd;
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 