commit 4c72a54cb0b2745713595adaecfc1bad548c03e0
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Jul 15 13:21:06 2019 +0200

    Massive overhaul:
    - updated to a new version of AMiRo-LLD
    - tests (formerly unit tests) are now split onto multiple parts:
      - there are "global" tests for each driver etc.
      - there is an individual part for each module, e.g. if there are multiple instances of the same periphery
    - a lot of minor enhancements

diff --git a/modules/PowerManagement_1-2/module.h b/modules/PowerManagement_1-2/module.h
index 468e72f..9c20fcc 100644
--- a/modules/PowerManagement_1-2/module.h
+++ b/modules/PowerManagement_1-2/module.h
@@ -434,37 +434,38 @@ extern ROMCONST char* moduleShellPrompt;
 }
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
   /* add unit-test shell commands */                                          \
-  aosShellAddCommand(&aos.shell, &moduleUtAdcVsys.shellcmd);                  \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldAt24c01b.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldBq24103a.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldBq27500.shellcmd);              \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldBq27500Bq24103a.shellcmd);      \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldIna219.shellcmd);               \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldPklcs1212e4001.shellcmd);       \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldLed.shellcmd);                  \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113.shellcmd);             \
-  aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113Ina219.shellcmd);       \
+  aosShellAddCommand(&aos.shell, &moduleTestAdcShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestAt24c01bShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestBq241xxShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestBq27500ShellCmd);                 \
+  aosShellAddCommand(&aos.shell, &moduleTestBq27500Bq241xxShellCmd);          \
+  aosShellAddCommand(&aos.shell, &moduleTestIna219ShellCmd);                  \
+  aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestPkxxxexxxShellCmd);               \
+  aosShellAddCommand(&aos.shell, &moduleTestTps6211xShellCmd);                \
+  aosShellAddCommand(&aos.shell, &moduleTestTps6211xIna219ShellCmd);          \
   MODULE_INIT_TEST_SENSORRING();                                              \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
 #if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
   #define MODULE_INIT_TEST_SENSORRING() {                                     \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldPca9544a.shellcmd);           \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldMpr121.shellcmd);             \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldVcnl4020.shellcmd);           \
+    aosShellAddCommand(&aos.shell, &moduleTestPca9544aShellCmd);              \
+    aosShellAddCommand(&aos.shell, &moduleTestMpr121ShellCmd);                \
+    aosShellAddCommand(&aos.shell, &moduleTestVcnl4020ShellCmd);              \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) || defined(__DOXYGEN__)
   #define MODULE_INIT_TEST_SENSORRING() {                                     \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldPcal6524.shellcmd);           \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldAt42qt1050.shellcmd);         \
+    aosShellAddCommand(&aos.shell, &moduleTestPcal6524ShellCmd);              \
+    aosShellAddCommand(&aos.shell, &moduleTestAt42qt1050ShellCmd);            \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) || defined(__DOXYGEN__)
   #define MODULE_INIT_TEST_SENSORRING() {                                     \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldPcal6524.shellcmd);           \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldAt42qt1050.shellcmd);         \
+    aosShellAddCommand(&aos.shell, &moduleTestPcal6524ShellCmd);              \
+    aosShellAddCommand(&aos.shell, &moduleTestAt42qt1050ShellCmd);            \
   }
 #else /* (BOARD_SENSORRING == ?) */
   #define MODULE_INIT_TEST_SENSORRING()         {}
@@ -473,8 +474,8 @@ extern ROMCONST char* moduleShellPrompt;
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
-  MODULE_INIT_PERIPHERY_COMM_SENSORRING();                                    \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
+  MODULE_INIT_PERIPHERY_IF_SENSORRING();                                      \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   /* I2C */                                                                   \
@@ -497,7 +498,7 @@ extern ROMCONST char* moduleShellPrompt;
   pwmStart(&MODULE_HAL_PWM_BUZZER, &moduleHalPwmBuzzerConfig);                \
 }
 #if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {                           \
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {                             \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (PCA9544A_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? PCA9544A_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (VCNL4020_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? VCNL4020_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (PCA9544A_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? PCA9544A_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed; \
@@ -505,25 +506,25 @@ extern ROMCONST char* moduleShellPrompt;
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (MPR121_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? MPR121_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed; \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) || defined(__DOXYGEN__)
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {                           \
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {                             \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (AT42QT1050_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? AT42QT1050_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
   }
 #elif (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) || defined(__DOXYGEN__)
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {                           \
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {                             \
     moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm18Pm33GaugeRearConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (PCAL6524_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? PCAL6524_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
     moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed = (AT42QT1050_LLD_I2C_MAXFREQUENCY < moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed) ? AT42QT1050_LLD_I2C_MAXFREQUENCY : moduleHalI2cSrPm42Pm50PmVddEepromGaugeFrontConfig.clock_speed;  \
   }
 #else /* (BOARD_SENSORRING == ?) */
-  #define MODULE_INIT_PERIPHERY_COMM_SENSORRING() {}
+  #define MODULE_INIT_PERIPHERY_IF_SENSORRING() {}
 #endif /* (BOARD_SENSORRING == ?) */
 
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
   /* PWM */                                                                   \
   pwmStop(&MODULE_HAL_PWM_BUZZER);                                            \
   /* ADC */                                                                   \
@@ -741,129 +742,114 @@ extern AT42QT1050Driver moduleLldTouch;
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
-#include <ut_lld_adc.h>
-#include <ut_alld_AT24C01B_v1.h>
-#include <ut_alld_bq241xx_v1.h>
-#include <ut_alld_bq27500_v1.h>
-#include <ut_alld_bq27500_v1_bq241xx_v1.h>
-#include <ut_alld_INA219_v1.h>
-#include <ut_alld_LED_v1.h>
-#include <ut_alld_PKxxxExxx_v1.h>
-#include <ut_alld_TPS6211x_v1.h>
-#include <ut_alld_TPS6211x_v1_INA219_v1.h>
 
 /**
- * @brief   ADC unit test object.
+ * @brief   ADC test command.
  */
-extern aos_unittest_t moduleUtAdcVsys;
+extern aos_shellcommand_t moduleTestAdcShellCmd;
 
 /**
- * @brief   AT24C01BN-SH-B (EEPROM) unit test object.
+ * @brief   AT24C01BN-SH-B (EEPROM) test command.
  */
-extern aos_unittest_t moduleUtAlldAt24c01b;
+extern aos_shellcommand_t moduleTestAt24c01bShellCmd;
 
 /**
- * @brief   BQ24103A (battery charger) unit test object.
+ * @brief   bq24103a (battery charger) test command.
  */
-extern aos_unittest_t moduleUtAlldBq24103a;
+extern aos_shellcommand_t moduleTestBq241xxShellCmd;
 
 /**
- * @brief   BQ27500 (fuel gauge) unit test object.
+ * @brief   bq27500 (fuel gauge) test command.
  */
-extern aos_unittest_t moduleUtAlldBq27500;
+extern aos_shellcommand_t moduleTestBq27500ShellCmd;
 
 /**
- * @brief   BQ27500 (fuela gauge) in combination with BQ24103A (battery charger) unit test object.
+ * @brief   bq27500 (fuel gauge) in combination with bq24103a (battery charger) test command.
  */
-extern aos_unittest_t moduleUtAlldBq27500Bq24103a;
+extern aos_shellcommand_t moduleTestBq27500Bq241xxShellCmd;
 
 /**
- * @brief   INA219 (power monitor) unit test object.
+ * @brief   INA219 (power monitor) test command.
  */
-extern aos_unittest_t moduleUtAlldIna219;
+extern aos_shellcommand_t moduleTestIna219ShellCmd;
 
 /**
- * @brief   Status LED unit test object.
+ * @brief   Status LED test command.
  */
-extern aos_unittest_t moduleUtAlldLed;
+extern aos_shellcommand_t moduleTestLedShellCmd;
 
 /**
- * @brief   PKLCS1212E4001 (buzzer) unit test object.
+ * @brief   PKLCS1212E4001 (buzzer) test command.
  */
-extern aos_unittest_t moduleUtAlldPklcs1212e4001;
+extern aos_shellcommand_t moduleTestPkxxxexxxShellCmd;
 
 /**
- * @brief   TPS62113 (step-down converter) unit test object.
+ * @brief   TPS62113 (step-down converter) test command.
  */
-extern aos_unittest_t moduleUtAlldTps62113;
+extern aos_shellcommand_t moduleTestTps6211xShellCmd;
 
 /**
- * @brief   TPS62113 (step-sown converter) in combination with INA219 (power monitor) unit test object.
+ * @brief   TPS62113 (step-sown converter) in combination with INA219 (power monitor) test command.
  */
-extern aos_unittest_t moduleUtAlldTps62113Ina219;
+extern aos_shellcommand_t moduleTestTps6211xIna219ShellCmd;
 
 #if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
 
-#include <ut_alld_MPR121_v1.h>
-#include <ut_alld_PCA9544A_v1.h>
-#include <ut_alld_VCNL4020_v1.h>
-
 /**
- * @brief   MPR121 (touch sensor) unit test object.
+ * @brief   MPR121 (touch sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldMpr121;
+extern aos_shellcommand_t moduleTestMpr121ShellCmd;
 
 /**
- * @brief   PCA9544A (I2C multiplexer) unit test object.
+ * @brief   PCA9544A (I2C multiplexer) test command.
  */
-extern aos_unittest_t moduleUtAlldPca9544a;
+extern aos_shellcommand_t moduleTestPca9544aShellCmd;
 
 /**
- * @brief   VCNL4020 (proximity sensor) unit test object.
+ * @brief   VCNL4020 (proximity sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldVcnl4020;
+extern aos_shellcommand_t moduleTestVcnl4020ShellCmd;
 
 #endif /* (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) */
 
 #if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) || defined(__DOXYGEN__)
 
-#include <ut_alld_PCAL6524_v1.h>
-#include <ut_alld_AT42QT1050_v1.h>
-
 /**
- * @brief   PCAL6524 (GPIO extender) unit test object.
+ * @brief   PCAL6524 (GPIO extender) test command.
  */
-extern aos_unittest_t moduleUtAlldPcal6524;
+extern aos_shellcommand_t moduleTestPcal6524ShellCmd;
 
 /**
- * @brief   AT42QT1050 (touch sensor) unit test object.
+ * @brief   AT42QT1050 (touch sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldAt42qt1050;
+extern aos_shellcommand_t moduleTestAt42qt1050ShellCmd;
 
 #endif /* (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L0X) */
 
 #if (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) || defined(__DOXYGEN__)
 
-#include <ut_alld_PCAL6524_v1.h>
-#include <ut_alld_AT42QT1050_v1.h>
-
 /**
- * @brief   PCAL6524 (GPIO extender) unit test object.
+ * @brief   PCAL6524 (GPIO extender) test command.
  */
-extern aos_unittest_t moduleUtAlldPcal6524;
+extern aos_shellcommand_t moduleTestPcal6524ShellCmd;
 
 /**
- * @brief   AT42QT1050 (touch sensor) unit test object.
+ * @brief   AT42QT1050 (touch sensor) test command.
  */
-extern aos_unittest_t moduleUtAlldAt42qt1050;
+extern aos_shellcommand_t moduleTestAt42qt1050ShellCmd;
 
 #endif /* (BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X) */
 
+/**
+ * @brief   Entire module test command.
+ */
+extern aos_shellcommand_t moduleTestAllShellCmd;
+
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
 /** @} */